module Hornetseye
  class Sequence_
    def labeling
      raise "Array must have two dimensions" if shape.size != 2
      raise "Elements must be of type UBYTE" if typecode != UBYTE
      ret = _labeling( memory.ptr, memory.offset, *shape )
      MultiArray( typecode, *shape ).new Memory.new( ret, 0 ), 0
    end
    def labeling_v1
      raise "Array must have two dimensions" if shape.size != 2
      raise "Elements must be of type UBYTE" if typecode != UBYTE
      ret = _labeling_1( memory.ptr, memory.offset, *shape )
      MultiArray( typecode, *shape ).new Memory.new( ret, 0 ), 0
    end
    def labeling_v2(w1,w2,h1,h2)
      raise "Array must have two dimensions" if shape.size != 2
      raise "Elements must be of type UBYTE" if typecode != UBYTE
      ret = _labeling_2( memory.ptr, memory.offset,
                         shape[0], shape[1],w1,w2,h1,h2 )
      MultiArray( typecode, *shape ).new Memory.new( ret, 0 ), 0
    end
    def areas
     aa = MultiArray.int(1000).fill!
     ret = _areas(memory.ptr,memory.offset,*shape)
     Sequence( aa.typecode, aa.size ).new Memory.new( ret, 0 ), 0
    end
    def centre_of_gravity
     aa = MultiArray.int(1000).fill!
     ret = _centre_of_gravity(memory.ptr,memory.offset,*shape)
     Sequence( aa.typecode, aa.size ).new Memory.new( ret, 0 ), 0
    end
  end
end

